%global name tendrl-api
%global app_group %{name}
%global app_user %{name}
%global install_dir %{_datadir}/%{name}
%global config_dir %{_sysconfdir}/tendrl
%global doc_dir %{_docdir}/%{name}
%global log_dir %{_var}/log/tendrl/api
%global tmp_dir %{_var}/tmp
%global config_file %{config_dir}/etcd.yml

Name: %{name}
Version: 1.6.3
Release: 10%{?dist}
Summary: Collection of tendrl api extensions
Group: Development/Languages
License: LGPLv2+
URL: https://github.com/Tendrl/api
Source0: %{name}-%{version}.tar.gz
BuildArch: noarch

BuildRequires: ruby
BuildRequires: systemd-units
BuildRequires: systemd

Requires: ruby >= 2.0.0
Requires: rubygem-activemodel >= 4.2.6
Requires: rubygem-bcrypt >= 3.1.10
Requires: rubygem-i18n >= 0.7.0
Requires: rubygem-json
Requires: rubygem-minitest >= 5.9.1
Requires: rubygem-thread_safe >= 0.3.5
Requires: rubygem-mixlib-log >= 1.7.1
Requires: rubygem-puma >= 3.6.0
Requires: rubygem-rake >= 0.9.6
Requires: rubygem-rack >= 1.6.4
Requires: rubygem-tilt >= 1.4.1
Requires: rubygem-bundler >= 1.13.6
Requires: rubygem-builder >= 3.1.0
Requires: rubygem-tzinfo >= 1.2.2
Requires: rubygem-etcd
Requires: rubygem-rack-protection >= 1.5.3
Requires: rubygem-activesupport >= 4.2.6
Requires: rubygem-sinatra >= 1.4.5
Requires: tendrl-node-agent

Patch0001: 0001-Fix-volume-bricks-API.patch
Patch0002: 0002-Fix-caching-issues-for-user-APIs.patch
Patch0003: 0003-Load_all-function-required-job_id-in-job-which-is-cr.patch
Patch0004: 0004-Restrict-username-length-to-20-chars.patch
Patch0005: 0005-Fix-recursion-over-etcd-keys-when-data-is-present-as.patch
Patch0006: 0006-Add-password-length-validation-9-128-chars.patch
Patch0007: 0007-Disallow-updating-username.patch
Patch0008: 0008-Running-Grafana-behind-a-reverse-proxy.patch
Patch0009: 0009-Logrotate-for-tendrl-api-log-files.patch
Patch0010: 0010-After-logrotate-logging-is-not-happening.patch

%description
Collection of tendrl api.

%package httpd
Summary: Tendrl api httpd
Requires: %{name} = %{version}-%{release}
BuildArch: noarch
Requires: httpd

%description httpd
Tendrl API httpd configuration.

%prep
%setup
%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1

%build

%install
install -m 0755 --directory $RPM_BUILD_ROOT%{log_dir}
install -m 0755 --directory $RPM_BUILD_ROOT%{install_dir}/app/controllers
install -m 0755 --directory $RPM_BUILD_ROOT%{install_dir}/app/forms
install -m 0755 --directory $RPM_BUILD_ROOT%{install_dir}/app/presenters
install -m 0755 --directory $RPM_BUILD_ROOT%{install_dir}/app/models
install -m 0755 --directory $RPM_BUILD_ROOT%{install_dir}/lib/tendrl/errors
install -m 0755 --directory $RPM_BUILD_ROOT%{doc_dir}/config
install -m 0755 --directory $RPM_BUILD_ROOT%{install_dir}/public
install -m 0755 --directory $RPM_BUILD_ROOT%{install_dir}/config
install -m 0755 --directory $RPM_BUILD_ROOT%{install_dir}/config/puma
install -m 0755 --directory $RPM_BUILD_ROOT%{install_dir}/config/initializers
install -m 0755 --directory $RPM_BUILD_ROOT%{install_dir}/.deploy
install -Dm 0644 Rakefile *.ru Gemfile* $RPM_BUILD_ROOT%{install_dir}
install -Dm 0644 app/controllers/*.rb $RPM_BUILD_ROOT%{install_dir}/app/controllers/
install -Dm 0644 app/forms/*.rb $RPM_BUILD_ROOT%{install_dir}/app/forms/
install -Dm 0644 app/presenters/*.rb $RPM_BUILD_ROOT%{install_dir}/app/presenters/
install -Dm 0644 app/models/*.rb $RPM_BUILD_ROOT%{install_dir}/app/models/
install -Dm 0644 lib/*.rb $RPM_BUILD_ROOT%{install_dir}/lib/
install -Dm 0644 lib/tendrl/*.rb $RPM_BUILD_ROOT%{install_dir}/lib/tendrl/
install -Dm 0644 lib/tendrl/errors/*.rb $RPM_BUILD_ROOT%{install_dir}/lib/tendrl/errors/
install -Dm 0644 tendrl-api.service $RPM_BUILD_ROOT%{_unitdir}/tendrl-api.service
install -Dm 0640 config/etcd.sample.yml $RPM_BUILD_ROOT%{config_file}
install -Dm 0644 README.adoc Rakefile $RPM_BUILD_ROOT%{doc_dir}
install -Dm 0644 config/apache.vhost-ssl.sample $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/tendrl-ssl.conf.sample
install -Dm 0644 config/apache.vhost.sample $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/tendrl.conf
install -Dm 0644 config/puma/*.rb $RPM_BUILD_ROOT%{install_dir}/config/puma/
install -Dm 0644 config/initializers/*.rb $RPM_BUILD_ROOT%{install_dir}/config/initializers/
install -Dm 0644 firewalld/tendrl-api.xml $RPM_BUILD_ROOT%{_prefix}/lib/firewalld/services/tendrl-api.xml
install -Dm 0644 config/tendrl-api_logrotate.conf $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/tendrl-api_logrotate.conf

# Symlink writable directories onto /var
ln -s %{log_dir} $RPM_BUILD_ROOT%{install_dir}/log
ln -s %{tmp_dir} $RPM_BUILD_ROOT%{install_dir}/tmp

%pre
getent group %{app_group} > /dev/null || \
    groupadd -r %{app_group}
getent passwd %{app_user} > /dev/null || \
    useradd -r -d %{install_dir} -M -g %{app_group} \
	    -s /sbin/nologin %{app_user}

%post httpd
setsebool -P httpd_can_network_connect 1
systemctl enable tendrl-api >/dev/null 2>&1 || :

%post
%systemd_post tendrl-api.service

%preun
%systemd_preun tendrl-api.service

%postun
%systemd_postun_with_restart tendrl-api.service

%files
%license LICENSE
%dir %attr(0755, %{app_user}, %{app_group}) %{log_dir}
%dir %{config_dir}
%{install_dir}/
%{doc_dir}/
%{_unitdir}/tendrl-api.service
%config(noreplace) %{_sysconfdir}/logrotate.d/tendrl-api_logrotate.conf
%config(noreplace) %attr(0640, root, %{app_group}) %{config_file}
%config(noreplace) %{_prefix}/lib/firewalld/services/tendrl-api.xml

%files httpd
%config(noreplace) %{_sysconfdir}/httpd/conf.d/tendrl-ssl.conf.sample
%config(noreplace) %{_sysconfdir}/httpd/conf.d/tendrl.conf

%changelog
* Sat Jan 19 2019 Timothy Asir J <tjeyasin@redhat.com> - 1.6.3-10
- Fixed bugs: 1654183
- Release tendrl-api 1.6.3-10

* Sat Jan 19 2019 Timothy Asir J <tjeyasin@redhat.com> - 1.6.3-9
- Fixed bugs: 1654183
- Release tendrl-api 1.6.3-9

* Mon Nov 05 2018 Timothy Asir J <tjeyasin@redhat.com> - 1.6.3-8
- Fixed bugs: 1590416
- Release tendrl-api 1.6.3-8

* Sat Sep 22 2018 Timothy Asir J <tjeyasin@redhat.com> - 1.6.3-7
- Fixed bugs: 1610660,1610947
- Release tendrl-api 1.6.3-7

* Fri Sep 21 2018 Timothy Asir J <tjeyasin@redhat.com> - 1.6.3-6
- Fixed bugs: 1610660,1610947
- Release tendrl-api 1.6.3-6

* Sun Jul 29 2018 Timothy Asir J <tjeyasin@redhat.com> - 1.6.3-5
- Fixed bugs: 1603175
- Release tendrl-api 1.6.3-5

* Thu Jul 05 2018 Timothy Asir J <tjeyasin@redhat.com> - 1.6.3-4
- Fixed bugs: 1592487,1594994
- Release tendrl-api 1.6.3-4

* Sat May 05 2018 Timothy Asir J <tjeyasin@redhat.com> - 1.6.3-3
- Fixed bugs: 1573928,1573950,1574453
- Release tendrl-api 1.6.3-3

* Wed Apr 25 2018 Timothy Asir J <tjeyasin@redhat.com> - 1.6.3-2
- Fixed bugs: 1569979
- Release tendrl-api 1.6.3-2

* Thu Apr 19 2018 Timothy Asir J <tjeyasin@redhat.com> - 1.6.3-1
- Release tendrl-api 1.6.3-1

* Mon Apr 02 2018 Timothy Asir J <tjeyasin@redhat.com> - 1.6.1-3
- Fixed bugs: 1555455, 1559373, 1559379, 1559379, 1559436
- Release tendrl-api 1.6.1-3

* Tue Mar 27 2018 Timothy Asir J <tjeyasin@redhat.com> - 1.6.1-2
- Fixed bugs: 1531139, 1516417
- Release tendrl-api 1.6.1-2

* Thu Mar 08 2018 Timothy Asir J <tjeyasin@redhat.com> - 1.6.1-1
- Release tendrl-api 1.6.1-1

* Thu Nov 30 2017 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 1.5.4-4
- Release tendrl-api 1.5.4-4

* Mon Nov 27 2017 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 1.5.4-3
- Release tendrl-api 1.5.4-3

* Fri Nov 10 2017 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 1.5.4-2
- Release tendrl-api 1.5.4-2

* Fri Nov 03 2017 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 1.5.4-1
- Release tendrl-api 1.5.4-1

* Fri Oct 13 2017 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 1.5.3-2
- Removed selinux package builds
- Release tendrl-api 1.5.3-2

* Thu Oct 12 2017 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 1.5.3-1
- Release tendrl-api 1.5.3-1

* Mon Jun 19 2017 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 3.0-alpha.5
- Release tendrl-api 3.0-alpha.5

* Thu Jun 08 2017 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 3.0-alpha.4
- Release tendrl-api 3.0-alpha.4

* Fri Jun 02 2017 Shubhendu Tripathi <shtripat@redhat.com> - 3.0-alpha.3
- Release tendrl-api 3.0-alpha.3

* Fri May 26 2017 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 3.0-alpha.2
- Release tendrl-api 3.0-alpha.2

* Thu May 25 2017 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 3.0-alpha.1
- Release tendrl-api 3.0-alpha.1

* Fri May 19 2017 Timothy Asir Jeyasingh <tjeyasin@redhat.com> - 3.0-alpha
- Release tendrl-api 3.0-alpha

* Fri Apr 5 2017 Anup Nivargi <anivargi@redhat.com> - 1.2-2
- Version bump to the 1.2.2 release.

* Fri Jan 27 2017 Mrugesh Karnik <mkarnik@redhat.com> - 1.2-1
- Version bump to the 1.2 release.

* Wed Nov 16 2016 Tim <tim.gluster@gmail.com> - 0.0.1-1
- Initial package
